import path from 'path';
import { BACKUP_EXT } from '../constants';
import isFunction from 'lodash/isFunction';
// Get the location of the backup file
export const getBackupFilePath = (mainPath, backupPath) => {
    if (backupPath) {
        return backupPath;
    }
    const ext = path.extname(mainPath);
    if (mainPath.endsWith(`${BACKUP_EXT}${ext}`)) {
        return mainPath;
    }
    return mainPath.replace(ext, BACKUP_EXT + ext);
};
export const defineRuleOptions = (options) => options;
export const compose = (...args) => (params) => args.reduce((prev, current) => {
    const result = isFunction(prev) ? prev(params) : prev;
    return current(result);
});
